<?php
//Declare variables used in GET request
$table = $_GET['table']; //i.e. 'viewer.partners_list'
$distinct = $_GET['distinct']; //i.e. true
$fields = $_GET['fields']; //i.e. ['partnerid', 'partner_name']
$condition = $_GET['condition']; //'partnerid' = 1 AND 'partner_name' = 'DWSD'
$drupalUserSwitch = $_GET['drupal_user_switch']; //i.e. true;
$drupalUser = $_GET['drupal_userid']; //i.e. 8
$sort = $_GET['sort']; //i.e. 'partnerid ASC'
$limit = $_GET['limit']; //i.e. '100'
$filterField = $_GET['filterField'];
$filterValue = $_GET['filterValue'];
$startDate = $_GET['startDate'];
$endDate = $_GET['endDate'];
$windowFunction = $_GET['windowFunction']; // boolean for whether SQL should include window function
$windowSumField = $_GET['windowSumField'];
$windowPartitionField = $_GET['windowPartitionField'];
$windowOrderField = $_GET['windowOrderField'];
$sql = "";
//Checks to confirm that user is logged in when request initiated and that request is initiated via ajax
if($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') {
  //Connection Credentials
  $host = 'localhost';
  $port = '5432';
  $dbName = 'CWID';
  $dbUser = 'dashboard_drupal';
  $dbPass = 'dashboarddrupal';
  //Connect to database
  $conn = pg_connect("host=$host port=$port dbname=$dbName user=$dbUser password=$dbPass") or die("Could not connect");
  //Log error if table name not provided
  if (!strlen(trim($table))) {
    echo "Error: Please specify a table name";
    exit;
  } 
  //Loop trough field names creating fields for select statement
  //adding commas after each field, but trim last comma
  $fieldstr = "";
  foreach ($fields as $i => $field){
    $fieldstr = $fieldstr . "$field, ";
  }
  $fieldstr = rtrim($fieldstr, ', ');
  //Log error if field names not provided
  if(!strlen(trim($fieldstr))) {
    echo "Error: Please specify table field(s)";
    exit;
  }

  //Create basic SQL query and $distinct boolean
  if ($distinct == true) {
    $sql = "SELECT DISTINCT $fieldstr FROM $table";
  } else if ($windowFunction) {
    $sql = "SELECT $fieldstr, SUM($windowSumField) OVER (PARTITION BY $windowPartitionField ORDER BY $windowOrderField) AS cumulative FROM $table";
  } else {
    $sql = "SELECT $fieldstr FROM $table";
  }

  // append period of record query if included
  /*if (strlen(trim($filterField)) && strlen(trim($filterValue))) {
    $sql .= " WHERE $filterField = $filterValue"; 
  } else {
    $sql;
  }*/

  if (strlen(trim($filterField))) {
    $sql .= " WHERE $filterField = $filterValue";
  } 
  
  if (strlen(trim($filterField)) && strlen(trim($startDate)) && strlen(trim($endDate))) {
    $sql .= " AND (date_time >=  '$startDate'::date AND date_time <= '$endDate'::date )";
  } else if (!strlen(trim($filterField)) && strlen(trim($startDate)) && strlen(trim($endDate))) {
    $sql .= " WHERE (date_time >=  '$startDate'::date AND date_time <= '$endDate'::date )";
  }

  // append period of record query if included
  /*if (strlen(trim($startDate)) && strlen(trim($endDate))) {
    $sql .= " AND (date_time >= . $startDate::date AND date_time <= $endDate::date )"; 
  } else {
    $sql;
  }*/
  
  //Append Drupal Userid to $sql if included
  if(strlen(trim($drupalUserSwitch))) {
    if (strlen(trim($drupalUser)) && (strlen(trim($filterField))) && $drupal_user_switch) {
      $sql .= " AND drupal_userid=" . $drupalUser;
    } elseif (strlen(trim($drupalUser)) && (!strlen(trim($filterField))) && $drupal_user_switch)  {
      $sql .= " WHERE drupal_userid=" . $drupalUser;
    } 
  } elseif (!strlen(trim($drupalUserSwitch))) {
    if (strlen(trim($drupalUser)) && (strlen(trim($filterField)))) {
      $sql .= " AND drupal_userid=" . $drupalUser;
    } elseif (strlen(trim($drupalUser)) && (!strlen(trim($filterField))))  {
      $sql .= " WHERE drupal_userid=" . $drupalUser;
    } 
  }

  //Append ORDER BY clause if included
  if (strlen(trim($sort))) {
    $sql .= " ORDER BY " . $sort;
  }

  //Append ORDER BY clause if included
  if (strlen(trim($limit))) {
    $sql .= " LIMIT " . $limit;
  }

  //send the query
  if (!$response = pg_query($conn, $sql)) {
     $errormessage = pg_last_error();
    echo "A query error occured.\n" . $errormessage;
    exit;
  }
  //Maybe remove this
  error_log(print_r($sql, TRUE));
  //Return response as json
  $resultArray = pg_fetch_all($response);
  echo json_encode($resultArray);
  pg_close($conn);
}
?>
